=== debian/changelog ===
rspamd (3.6-1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
      building on ubuntu and for armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 11 Aug 2023 11:56:41 +0200

rspamd (3.6-1) unstable; urgency=medium

  * New upstream version 3.6
  * lintian: update version number
  * d/patches: refresh patches

 -- Sebastien Badia <sbadia@debian.org>  Tue, 08 Aug 2023 21:14:35 +0200

rspamd (3.5-1ubuntu3) mantic; urgency=medium

  * Link latomic on riscv64 to fix a build failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 31 Jul 2023 08:40:39 +0200

rspamd (3.5-1ubuntu1) mantic; urgency=medium

  * d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
    building on ubuntu and for armhf (LP: #2027879)

 -- Andreas Hasenack <andreas@canonical.com>  Mon, 17 Jul 2023 17:13:27 -0300

rspamd (3.5-1) unstable; urgency=medium

  * d/copyright: Update Vsevolod email
  * New upstream version 3.5 (Closes: #1037486, #1037849, #1036646)
  * d/patches:
    + removed upstream patches
    + refresh patches according new upstream

 -- Sebastien Badia <sbadia@debian.org>  Sun, 25 Jun 2023 01:22:24 +0200
