## rspamd 3.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,18 +8,20 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.12 FATAL_ERROR)
 
 SET(RSPAMD_VERSION_MAJOR 3)
-SET(RSPAMD_VERSION_MINOR 6)
+SET(RSPAMD_VERSION_MINOR 7)
+SET(RSPAMD_VERSION_PATCH 3)
 
 # Keep two digits all the time
 SET(RSPAMD_VERSION_MAJOR_NUM ${RSPAMD_VERSION_MAJOR}0)
 SET(RSPAMD_VERSION_MINOR_NUM ${RSPAMD_VERSION_MINOR}0)
+SET(RSPAMD_VERSION_PATCH_NUM ${RSPAMD_VERSION_PATCH}0)
 
 IF (GIT_ID)
     SET(GIT_VERSION 1)
     SET(RSPAMD_ID "${GIT_ID}")
 ENDIF ()
 
-SET(RSPAMD_VERSION "${RSPAMD_VERSION_MAJOR}.${RSPAMD_VERSION_MINOR}")
+SET(RSPAMD_VERSION "${RSPAMD_VERSION_MAJOR}.${RSPAMD_VERSION_MINOR}.${RSPAMD_VERSION_PATCH}")
 
 PROJECT(rspamd VERSION "${RSPAMD_VERSION}" LANGUAGES C CXX ASM)
 
@@ -54,10 +56,11 @@
 OPTION(ENABLE_PCRE2 "Enable pcre2 instead of pcre  [default: ON]" ON)
 OPTION(ENABLE_JEMALLOC "Build rspamd with jemalloc allocator  [default: OFF]" OFF)
 OPTION(ENABLE_UTILS "Build rspamd internal utils [default: OFF]" OFF)
-OPTION(ENABLE_LIBUNWIND "Use libunwind to print crash traces [default: OFF]" OFF)
+OPTION(ENABLE_LIBUNWIND "Obsoleted [default: OFF]" OFF)
 OPTION(ENABLE_LUA_TRACE "Trace all Lua C API invocations [default: OFF]" OFF)
 OPTION(ENABLE_LUA_REPL "Enables Lua repl (requires C++11 compiler) [default: ON]" ON)
 OPTION(ENABLE_FASTTEXT "Link with FastText library [default: OFF]" OFF)
+OPTION(ENABLE_BACKWARD "Build rspamd with backward-cpp stacktrace [default: ON]" ON)
 OPTION(SYSTEM_ZSTD "Use system zstd instead of bundled one [default: OFF]" OFF)
 OPTION(SYSTEM_FMT "Use system fmt instead of bundled one [default: OFF]" OFF)
 OPTION(SYSTEM_DOCTEST "Use system doctest instead of bundled one [default: OFF]" OFF)
@@ -204,12 +207,6 @@
     ProcessPackage(JEMALLOC LIBRARY jemalloc_pic jemalloc INCLUDE jemalloc.h INCLUDE_SUFFIXES include/jemalloc
             ROOT ${JEMALLOC_ROOT_DIR})
     SET(WITH_JEMALLOC "1")
-ENDIF ()
-
-IF (ENABLE_LIBUNWIND MATCHES "ON")
-    ProcessPackage(LIBUNWIND LIBRARY unwind INCLUDE libunwind.h INCLUDE_SUFFIXES include/libunwind
-            ROOT ${LIBUNWIND_ROOT_DIR} MODULES libunwind)
-    SET(WITH_LIBUNWIND "1")
 ENDIF ()
 
 ProcessPackage(GLIB2 LIBRARY glib-2.0 INCLUDE glib.h
@@ -315,3 +312,6 @@
 CHECK_INCLUDE_FILES(cpuid.h HAVE_CPUID_H)
 CHECK_INCLUDE_FILES(dirent.h HAVE_DIRENT_H)
 CHECK_INCLUDE_FILES(ucontext.h HAVE_UCONTEXT_H)
+CHECK_INCLUDE_FILES(sys/ucontext.h HAVE_SYS_UCONTEXT_H) # OSX specific
+
+# Check platform API
