=== debian/changelog ===
rspamd (3.7.3-1ubuntu2) noble; urgency=medium

  * No-change rebuild for ICU soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 11:07:54 +0100

rspamd (3.7.3-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
      building on ubuntu and for armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 29 Oct 2023 08:46:03 +0100

rspamd (3.7.3-1) unstable; urgency=medium

  * New upstream version 3.7.3

 -- Sebastien Badia <sbadia@debian.org>  Sat, 28 Oct 2023 00:14:48 +0200

rspamd (3.7.2-1) unstable; urgency=medium

  * New upstream version 3.7.2
  * d/patches: refresh patches

 -- Sebastien Badia <sbadia@debian.org>  Thu, 26 Oct 2023 22:33:03 +0200

rspamd (3.7.1-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
      building on ubuntu and for armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 26 Oct 2023 09:14:31 +0200

rspamd (3.7.1-1) unstable; urgency=medium

  * New upstream version 3.7.1
  * d/patches: refresh patches (bootstrap 5.3.1, jquery 3.7.0)
  * d/lintian: update version number

 -- Sebastien Badia <sbadia@debian.org>  Tue, 10 Oct 2023 14:52:39 +0200
