## rspamd 3.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,8 +8,8 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.12 FATAL_ERROR)
 
 SET(RSPAMD_VERSION_MAJOR 3)
-SET(RSPAMD_VERSION_MINOR 7)
-SET(RSPAMD_VERSION_PATCH 3)
+SET(RSPAMD_VERSION_MINOR 8)
+SET(RSPAMD_VERSION_PATCH 1)
 
 # Keep two digits all the time
 SET(RSPAMD_VERSION_MAJOR_NUM ${RSPAMD_VERSION_MAJOR}0)
@@ -242,8 +242,7 @@
         ROOT ${LIBSODIUM_ROOT_DIR} MODULES libsodium>=1.0.0)
 
 if (ENABLE_FASTTEXT MATCHES "ON")
-    ProcessPackage(FASTTEXT LIBRARY fasttext INCLUDE fasttext.h
-            INCLUDE_SUFFIXES include/fasttext
+    ProcessPackage(FASTTEXT LIBRARY fasttext INCLUDE fasttext/fasttext.h
             ROOT ${FASTTEXT_ROOT_DIR} MODULES fasttext)
     SET(WITH_FASTTEXT "1")
 endif ()
@@ -315,3 +314,4 @@
 CHECK_INCLUDE_FILES(sys/ucontext.h HAVE_SYS_UCONTEXT_H) # OSX specific
 
 # Check platform API
+IF(NOT CMAKE_SYSTEM_NAME STREQUAL "Linux")
