=== src/rspamadm/CMakeLists.txt ===
--- 
+++ 
@@ -27,4 +27,5 @@
 ENDIF (NOT DEBIAN_BUILD)
 
 SET_TARGET_PROPERTIES(rspamadm PROPERTIES LINKER_LANGUAGE CXX)
+ADD_BACKWARD(rspamadm)
 INSTALL(TARGETS rspamadm RUNTIME DESTINATION bin)
