=== debian/changelog ===
rspamd (3.8.1-1.2ubuntu2) plucky; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 05 Jan 2025 20:29:41 +0100

rspamd (3.8.1-1.2ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
    - d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
      building on ubuntu and for armhf

 -- Matthias Klose <doko@ubuntu.com>  Mon, 28 Oct 2024 08:54:23 +0100

rspamd (3.8.1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "autopkgtest regression with Perl 5.40: FAIL stderr: Duplicate
    specification": add patches from Niko Tiny to fix Getopt::Long usage with
    Perl 5.40. (Closes: #1078150)

 -- gregor herrmann <gregoa@debian.org>  Mon, 16 Sep 2024 23:23:06 +0200

rspamd (3.8.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Install systemd unit into /usr (DEP17 M2) (Closes: #1071914)

 -- Chris Hofstaedtler <zeha@debian.org>  Tue, 11 Jun 2024 00:57:11 +0200

rspamd (3.8.1-1ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:56:03 +1100

rspamd (3.8.1-1ubuntu2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:11:51 +0000

rspamd (3.8.1-1ubuntu1) noble; urgency=medium

  * Merge with Debian; remaining changes:
    - d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
      building on ubuntu and for armhf

 -- Matthias Klose <doko@ubuntu.com>  Thu, 29 Feb 2024 13:19:43 +0100

rspamd (3.8.1-1) unstable; urgency=medium

  * New upstream version 3.8.1
  * d/patches: refresh patches
  * d/lintian: update version number
  * d/copyright: Update years and my email
  * d/sources: Update github.com/julianpoemp/codejar-linenumbers

 -- Sebastien Badia <sbadia@debian.org>  Sat, 27 Jan 2024 22:50:06 +0100
