## rspamd 3.8.4

=== debian/changelog ===
rspamd (3.8.4-1~93fa4f6dc~noble) UNRELEASED; urgency=medium

  * Automated build

 -- Vsevolod Stakhov <vsevolod@rspamd.com>  Mon, 26 Feb 2024 09:41:06 +0000

rspamd (2.5) unstable; urgency=low

  * New release.

 -- Vsevolod Stakhov <vsevolod@rspamd.com>  Fri, 16 Feb 2020 23:10:27 +0000
